diff -uNr src.ORIG/mclibs/herwig/code/hwwarn.F src/mclibs/herwig/code/hwwarn.F
--- src.ORIG/mclibs/herwig/code/hwwarn.F	1996-12-03 23:17:06.000000000 +0900
+++ src/mclibs/herwig/code/hwwarn.F	2005-05-30 18:09:44.000000000 +0900
@@ -2,7 +2,11 @@
 *CMZ :-        -26/04/91  10.18.58  by  Bryan Webber
 *-- Author :    Bryan Webber
 C-----------------------------------------------------------------------
+#if !defined(CERNLIB_GFORTRAN)
       SUBROUTINE HWWARN(SUBRTN,ICODE,*)
+#else
+      SUBROUTINE HWWARN(SUBRTN,ICODE,iret)
+#endif
 C-----------------------------------------------------------------------
 C     DEALS WITH ERRORS DURING EXECUTION
 C     SUBRTN = NAME OF CALLING SUBROUTINE
@@ -18,22 +22,45 @@
       INCLUDE 'HERWIG59.INC'
       INTEGER ICODE
       CHARACTER*6 SUBRTN
+#if defined(CERNLIB_GFORTRAN)
+      integer iret
+#endif
       IF (ICODE.GE.0) WRITE (6,10) SUBRTN,ICODE
    10 FORMAT(/' HWWARN CALLED FROM SUBPROGRAM ',A6,': CODE =',I4)
       IF (ICODE.LT.0) THEN
          IERROR=ICODE
+#if !defined(CERNLIB_GFORTRAN)
          RETURN 1
+#else
+         iret = 1
+         return
+#endif
       ELSEIF (ICODE.LT.100) THEN
          WRITE (6,20) NEVHEP,NRN,EVWGT
    20    FORMAT(' EVENT',I8,':   SEEDS =',I11,' &',I11,
      &'  WEIGHT =',E11.4/' EVENT SURVIVES. EXECUTION CONTINUES')
+#if !defined(CERNLIB_GFORTRAN)
          IF (ICODE.GT.49) RETURN 1
+#else
+         if (icode.gt.49) then
+           iret = 1
+           return
+         else
+	   iret = 0
+           return
+         endif
+#endif
       ELSEIF (ICODE.LT.200) THEN
          WRITE (6,30) NEVHEP,NRN,EVWGT
    30    FORMAT(' EVENT',I8,':   SEEDS =',I11,' &',I11,
      &'  WEIGHT =',E11.4/' EVENT KILLED.   EXECUTION CONTINUES')
          IERROR=ICODE
+#if !defined(CERNLIB_GFORTRAN)
          RETURN 1
+#else
+         iret = 1
+         return
+#endif
       ELSEIF (ICODE.LT.300) THEN
          WRITE (6,40)
    40    FORMAT(' EVENT SURVIVES.  RUN ENDS GRACEFULLY')
diff -uNr src.ORIG/mclibs/isajet/code/cteq5l.F src/mclibs/isajet/code/cteq5l.F
--- src.ORIG/mclibs/isajet/code/cteq5l.F	2001-10-08 23:03:03.000000000 +0900
+++ src/mclibs/isajet/code/cteq5l.F	2005-05-30 16:50:34.000000000 +0900
@@ -228,7 +228,12 @@
       DO 100 I = 0, NEX
          AF(I) = 0.D0
          SBX = 1.D0
+#if !defined(CERNLIB_GFORTRAN)
          DO 110 K = 0, MLFVEC(IFL)
+#else
+         NMLFV = MLFVEC(IFL)
+         DO 110 K = 0, NMLFV
+#endif
             AF(I) = AF(I) + SBX*AM(I,K,IFL)
             SBX = SB1*SBX
 110      CONTINUE
diff -uNr src.ORIG/mclibs/isajet/code/sigqcd.F src/mclibs/isajet/code/sigqcd.F
--- src.ORIG/mclibs/isajet/code/sigqcd.F	1996-12-05 02:38:26.000000000 +0900
+++ src/mclibs/isajet/code/sigqcd.F	2005-05-30 16:54:28.000000000 +0900
@@ -213,7 +213,11 @@
 250   CONTINUE
 C
 C          Gluon + heavy quark
+#if !defined(CERNLIB_GFORTRAN)
       DO 300 IQ=8,13.
+#else
+      DO 300 IQ=8,13
+#endif
         IF(.NOT.(GOQ(1,1).AND.GOQ(IQ,2))) GO TO 310
         AMQ=AMASS(IQ/2)
         AM2=AMQ**2
diff -uNr src.ORIG/mclibs/pythia/code/visaje.F src/mclibs/pythia/code/visaje.F
--- src.ORIG/mclibs/pythia/code/visaje.F	2002-04-11 01:03:24.000000000 +0900
+++ src/mclibs/pythia/code/visaje.F	2005-05-30 17:40:55.000000000 +0900
@@ -7,7 +7,9 @@
       FUNCTION VISAJE()
       IMPLICIT DOUBLE PRECISION(A-H, O-Z)
       IMPLICIT INTEGER(I-N)
+#if !defined(CERNLIB_GFORTRAN)
       CHARACTER*40 VISAJE
+#endif
  
 C...Commonblocks.
       COMMON/PYDAT1/MSTU(200),PARU(200),MSTJ(200),PARJ(200)
diff -uNr src.ORIG/packlib/kernlib/kerngen/tcgen/tcdump.F src/packlib/kernlib/kerngen/tcgen/tcdump.F
--- src.ORIG/packlib/kernlib/kerngen/tcgen/tcdump.F	1996-02-16 02:49:50.000000000 +0900
+++ src/packlib/kernlib/kerngen/tcgen/tcdump.F	2005-05-28 23:32:51.000000000 +0900
@@ -16,7 +16,11 @@
 C
 C
       CALL UBLOW (  IND,IDN,3)
+#if defined(CERNLIB_QRTHOLL)
       CALL UBLOW (3HIFH,IFM,3)
+#else
+      CALL UBLOW ('IFH',IFM,3)
+#endif
       DO 12 J=1,3
       IF (IUCOMP(IFM(J),IDN,3).EQ.0)  IFM(J)=0
    12 CONTINUE
diff -uNr src.ORIG/pawlib/comis/code/csjtjp.F src/pawlib/comis/code/csjtjp.F
--- src.ORIG/pawlib/comis/code/csjtjp.F	1996-02-27 02:16:22.000000000 +0900
+++ src/pawlib/comis/code/csjtjp.F	2005-05-28 23:39:10.000000000 +0900
@@ -101,7 +101,11 @@
       IF(N.LE.0)THEN
         N=4
         IF(N.GT.NTB)GO TO 3
+#if defined(CERNLIB_QRTHOLL)
         CALL CCOPYS(MJCHAR(4H*PAR),JST,4)
+#else
+        CALL CCOPYS(MJCHAR('*PAR'),JST,4)
+#endif
         JST=JST+4
       ENDIF
       NW=(N-1)/NBYTPW+1
diff -uNr src.ORIG/pawlib/paw/code/palogo.F src/pawlib/paw/code/palogo.F
--- src.ORIG/pawlib/paw/code/palogo.F	2004-01-13 23:33:39.000000000 +0900
+++ src/pawlib/paw/code/palogo.F	2005-05-28 23:59:15.000000000 +0900
@@ -325,7 +325,11 @@
 *
       TCARD=' '
       CALL UHTOC(
+#if defined(CERNLIB_QRTHOLL)
      + 40HPAW      2.14/04  12/01/04  10.45.00     
+#else
+     + 'PAW      2.14/04  12/01/04  10.45.00    ' 
+#endif
 #if !defined(CERNLIB_CRAY)
      +,4,TCARD,26)
 #endif
diff -uNr src.ORIG/pawlib/paw/code/paspi2.F src/pawlib/paw/code/paspi2.F
--- src.ORIG/pawlib/paw/code/paspi2.F	1996-08-21 22:58:20.000000000 +0900
+++ src/pawlib/paw/code/paspi2.F	2005-05-29 00:05:32.000000000 +0900
@@ -348,11 +348,21 @@
       CALL IGSET ('LTYP', 3.0)
 *
       IF (RZONE.LT.4.0) THEN
+#if !defined(CERNLIB_GFORTRAN)
        DO 60 R=0.1, 1.0, 0.1
+#else
+       DO 60 IR=1,10
+          R = 0.1*I
+#endif
           CALL IGARC (0.0, 0.0, R, R, 0.0, 0.0)
    60    CONTINUE
       ELSE
+#if !defined(CERNLIB_GFORTRAN)
        DO 70 R=0.25, 1.0, 0.25
+#else
+       DO 70 IR=1,4
+          R = 0.25*I
+#endif
           CALL IGARC (0.0, 0.0, R, R, 0.0, 0.0)
    70    CONTINUE
       ENDIF
diff -uNr src.ORIG/pawlib/paw/fmotif/Imakefile src/pawlib/paw/fmotif/Imakefile
--- src.ORIG/pawlib/paw/fmotif/Imakefile	1996-09-23 23:20:46.000000000 +0900
+++ src/pawlib/paw/fmotif/Imakefile	2005-05-29 00:18:38.000000000 +0900
@@ -2,7 +2,7 @@
 	ntwini.F pamloc.F pbhist.F pbhlun.F pbpiaf.F pbplun.F \ @@\
 	plotisto.F pmhist.F pminit.F show_chain.F
 
-#ifdef CERNLIB_LINUX
+#if defined(CERNLIB_LINUX) && !defined(CERNLIB_GFORTRAN)
 FORTRANOPTIONS = -fno-backslash  $(FORTRANSAVEOPTION) -fno-second-underscore
 #endif
 
diff -uNr src.ORIG/pawlib/sigma/src/siallm.F src/pawlib/sigma/src/siallm.F
--- src.ORIG/pawlib/sigma/src/siallm.F	1995-12-12 23:36:15.000000000 +0900
+++ src/pawlib/sigma/src/siallm.F	2005-05-29 01:03:06.000000000 +0900
@@ -108,9 +108,20 @@
       GO TO 37
    21 IF(N.EQ.2)GO TO 2
    22 MN1=M-N+1
+#if !defined(CERNLIB_GFORTRAN)
       IF(REAL(A(N,N)).NE.0..OR.AIMAG(A(N,N)).NE.0.)
      1 IF(ABS(REAL(A(N,N-1)/A(N,N)))+ABS(AIMAG(A(N,N-1)/A(N,N)))-1.E-9)
      2 24,24,23
+#else
+      IF (REAL(A(N,N)).NE.0..OR.AIMAG(A(N,N)).NE.0.) THEN
+         IF (ABS(REAL(A(N,N-1)/A(N,N)))+ABS(AIMAG(A(N,N-1)/A(N,N)))
+     +        -1.E-9.LE.0.) THEN
+            GO TO 24
+         ELSE 
+            GO TO 23
+         ENDIF
+      ENDIF
+#endif
    23 IF(ABS(REAL(A(N,N-1)))+ABS(AIMAG(A(N,N-1))).GE.EPS)GO TO 25
    24 LAMBDA(MN1)=A(N,N)+SHIFT(1)
       ICOUNT=0
diff -uNr src.ORIG/phtools/fowl/redat2.F src/phtools/fowl/redat2.F
--- src.ORIG/phtools/fowl/redat2.F	1996-03-23 01:42:47.000000000 +0900
+++ src/phtools/fowl/redat2.F	2005-05-30 17:52:36.000000000 +0900
@@ -170,7 +170,11 @@
       IF(HISTIT(I).EQ.BLANK) CALL UCOPY(10H..........,HISTIT(I),1)
 #endif
 #if !defined(CERNLIB_CDC)
+#if !defined(CERNLIB_GFORTRAN)
       IF(HISTIT(I).EQ.BLANK) CALL UCOPY(4H....,HISTIT(I),1)
+#else
+      IF(HISTIT(I).EQ.BLANK) CALL UCOPY('....',HISTIT(I),1)
+#endif
 #endif
    77 BINS(LMLI) = HISTIT(I)
       NHIST = MAX(NHIST,IHIST)
@@ -215,7 +219,11 @@
       IF(HISTIT(I).EQ.BLANK) CALL UCOPY(10H..........,HISTIT(I),1)
 #endif
 #if !defined(CERNLIB_CDC)
+#if !defined(CERNLIB_GFORTRAN)
       IF(HISTIT(I).EQ.BLANK) CALL UCOPY(4H....,HISTIT(I),1)
+#else
+      IF(HISTIT(I).EQ.BLANK) CALL UCOPY('....',HISTIT(I),1)
+#endif
 #endif
   187 BINS(LNEXT+I-1) = HISTIT(I)
       GOTO 89
